Subject: [PATCH] genirq: provide means to retrigger parent

From: [email-masked] (Kevin Hilman)
Date: Tue, 23 Oct 2012 15:23:04 -0700

Russell King - ARM Linux <[email-masked]> writes:

> On Tue, Oct 16, 2012 at 03:07:49PM -0700, Kevin Hilman wrote:
>> From: Thomas Gleixner <[email-masked]>
>> 
>> Attempts to retrigger nested threaded IRQs currently fail because they
>> have no primary handler.  In order to support retrigger of nested
>> IRQs, the parent IRQ needs to be retriggered.
>> 
>> To fix, when an IRQ needs to be resent, if the interrupt has a parent
>> IRQ and runs in the context of the parent IRQ, then resend the parent.
>> 
>> Also, handle_nested_irq() needs to clear the replay flag like the
>> other handlers, otherwise check_irq_resend() will set it and it will
>> never be cleared.  Without clearing, it results in the first resend
>> working fine, but check_irq_resend() returning early on subsequent
>> resends because the replay flag is still set.
>> 
>> Problem discovered on ARM/OMAP platforms where a nested IRQ that's
>> also a wakeup IRQ happens late in suspend and needed to be retriggered
>> during the resume process.
>> 
>> Reported-by: Kevin Hilman <[email-masked]>
>> Tested-by: Kevin Hilman <[email-masked]>
>> [khilman at ti.com: changelog edits, clear IRQS_REPLAY in handle_nested_irq()]
>> Signed-off-by: Thomas Gleixner <[email-masked]>
>
> Umm, we also have the converse situation.  We have platforms where the
> resend has to be done from the child IRQ, and the parent must not be
> touched.  I hope that doesn't break those.

I'm assuming the child IRQs you're concerned with are not threaded,
right?  This patch only addresses nested, threaded IRQs, and these don't
have a primary handler to run at all, so cannot do any triggering.

Kevin